#version 330

// The first defined out variable of the fragment shader defines
// with which color the fragment is rendered:
out vec4 fragment_color;

// The value of this variable comes from the vertex shader
// (see 'out vec4 color;' there).
//
// Note that input variables in the fragment shader, which comes
// from the vertex shader, are automatically interpolated (at the
// triangle).

in vec4 color;

// Since this is the fragment shader, the following program is executed
// for each fragment of the triangle. There are as many fragments as the
// number of pixels of the screen on which the triangle is drawn.

void main()
{
    // Set the output color variable to the color of the vertex:
    fragment_color = color;
}
