#include "Mesh.h"

#include <iostream>

Mesh::Mesh(std::vector<Triangle> triangles)
    : triangles(triangles)
{
    // TODO 1: Create three VBOs and one VAO and store their
    // IDs into the attributes vbo_position, vbo_normal,
    // vbo_color and vao. Upload the data of the triangles-
    // Parameter correctly into the VBOs. Link the VBOs
    // correctly with the VAOs as it is described in the
    // assignment sheet and the tutorial sheet.
    //
    // TODO 2: Set the attribute vertices_num correctly so
    // that the triangle can be drawn!
}

Mesh::~Mesh(){
    // If there is a vao, delete it from the GPU:
    if(vao != 0)
        glDeleteVertexArrays(1, &vao);

    // If there is a vbo for the positions, delete it from the GPU:
    if(vbo_position != 0)
        glDeleteBuffers(1, &vbo_position);

    // If there is a vbo for the normals, delete it from the GPU:
    if(vbo_normal != 0)
        glDeleteBuffers(1, &vbo_normal);

    // If there is a vbo for the colors, delete it from the GPU:
    if(vbo_color != 0)
        glDeleteBuffers(1, &vbo_color);

    // To avoid reusage after deletion:
    vao = 0;
    vbo_position = 0;
    vbo_normal = 0;
    vbo_color = 0;
    verticesNum = 0;
}

void Mesh::render(){
    // Draws the geometry data that is defined by the vao:
    glBindVertexArray(vao);
    glDrawArrays(GL_TRIANGLES, 0, verticesNum);
}
